/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the CloneOptions type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CloneOptions{}

// CloneOptions struct for CloneOptions
type CloneOptions struct {
	ChannelIds []string `json:"channel_ids"`
	ReuseScripts *bool `json:"reuse_scripts,omitempty"`
	RolloutVersion *string `json:"rollout_version,omitempty"`
	ForceGlobalMedia *bool `json:"force_global_media,omitempty"`
}

// NewCloneOptions instantiates a new CloneOptions object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCloneOptions(channelIds []string) *CloneOptions {
	this := CloneOptions{}
	this.ChannelIds = channelIds
	return &this
}

// NewCloneOptionsWithDefaults instantiates a new CloneOptions object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCloneOptionsWithDefaults() *CloneOptions {
	this := CloneOptions{}
	return &this
}

// GetChannelIds returns the ChannelIds field value
func (o *CloneOptions) GetChannelIds() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.ChannelIds
}

// GetChannelIdsOk returns a tuple with the ChannelIds field value
// and a boolean to check if the value has been set.
func (o *CloneOptions) GetChannelIdsOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ChannelIds, true
}

// SetChannelIds sets field value
func (o *CloneOptions) SetChannelIds(v []string) {
	o.ChannelIds = v
}

// GetReuseScripts returns the ReuseScripts field value if set, zero value otherwise.
func (o *CloneOptions) GetReuseScripts() bool {
	if o == nil || IsNil(o.ReuseScripts) {
		var ret bool
		return ret
	}
	return *o.ReuseScripts
}

// GetReuseScriptsOk returns a tuple with the ReuseScripts field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CloneOptions) GetReuseScriptsOk() (*bool, bool) {
	if o == nil || IsNil(o.ReuseScripts) {
		return nil, false
	}
	return o.ReuseScripts, true
}

// HasReuseScripts returns a boolean if a field has been set.
func (o *CloneOptions) HasReuseScripts() bool {
	if o != nil && !IsNil(o.ReuseScripts) {
		return true
	}

	return false
}

// SetReuseScripts gets a reference to the given bool and assigns it to the ReuseScripts field.
func (o *CloneOptions) SetReuseScripts(v bool) {
	o.ReuseScripts = &v
}

// GetRolloutVersion returns the RolloutVersion field value if set, zero value otherwise.
func (o *CloneOptions) GetRolloutVersion() string {
	if o == nil || IsNil(o.RolloutVersion) {
		var ret string
		return ret
	}
	return *o.RolloutVersion
}

// GetRolloutVersionOk returns a tuple with the RolloutVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CloneOptions) GetRolloutVersionOk() (*string, bool) {
	if o == nil || IsNil(o.RolloutVersion) {
		return nil, false
	}
	return o.RolloutVersion, true
}

// HasRolloutVersion returns a boolean if a field has been set.
func (o *CloneOptions) HasRolloutVersion() bool {
	if o != nil && !IsNil(o.RolloutVersion) {
		return true
	}

	return false
}

// SetRolloutVersion gets a reference to the given string and assigns it to the RolloutVersion field.
func (o *CloneOptions) SetRolloutVersion(v string) {
	o.RolloutVersion = &v
}

// GetForceGlobalMedia returns the ForceGlobalMedia field value if set, zero value otherwise.
func (o *CloneOptions) GetForceGlobalMedia() bool {
	if o == nil || IsNil(o.ForceGlobalMedia) {
		var ret bool
		return ret
	}
	return *o.ForceGlobalMedia
}

// GetForceGlobalMediaOk returns a tuple with the ForceGlobalMedia field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CloneOptions) GetForceGlobalMediaOk() (*bool, bool) {
	if o == nil || IsNil(o.ForceGlobalMedia) {
		return nil, false
	}
	return o.ForceGlobalMedia, true
}

// HasForceGlobalMedia returns a boolean if a field has been set.
func (o *CloneOptions) HasForceGlobalMedia() bool {
	if o != nil && !IsNil(o.ForceGlobalMedia) {
		return true
	}

	return false
}

// SetForceGlobalMedia gets a reference to the given bool and assigns it to the ForceGlobalMedia field.
func (o *CloneOptions) SetForceGlobalMedia(v bool) {
	o.ForceGlobalMedia = &v
}

func (o CloneOptions) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CloneOptions) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["channel_ids"] = o.ChannelIds
	if !IsNil(o.ReuseScripts) {
		toSerialize["reuse_scripts"] = o.ReuseScripts
	}
	if !IsNil(o.RolloutVersion) {
		toSerialize["rollout_version"] = o.RolloutVersion
	}
	if !IsNil(o.ForceGlobalMedia) {
		toSerialize["force_global_media"] = o.ForceGlobalMedia
	}
	return toSerialize, nil
}

type NullableCloneOptions struct {
	value *CloneOptions
	isSet bool
}

func (v NullableCloneOptions) Get() *CloneOptions {
	return v.value
}

func (v *NullableCloneOptions) Set(val *CloneOptions) {
	v.value = val
	v.isSet = true
}

func (v NullableCloneOptions) IsSet() bool {
	return v.isSet
}

func (v *NullableCloneOptions) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCloneOptions(val *CloneOptions) *NullableCloneOptions {
	return &NullableCloneOptions{value: val, isSet: true}
}

func (v NullableCloneOptions) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCloneOptions) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


